stages:
  - build
  - release

build-linux:
  stage: build
  image: golang:1.12.7-alpine
  only:
    changes:
      - /*.go$/
  variables:
    PLATFORM: 'linux'
    ARCH: 'amd64'
  before_script:
    - apk add --no-cache git upx
  script:
    - go get -d -v ./...
    - GOOS=${PLATFORM} GOARCH=${ARCH} go build -ldflags="-s -w" -o ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH} *.go
    - upx ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}
    - gzip ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}
  artifacts:
    untracked: true

build-darwin:
  stage: build
  image: golang:1.12.7-alpine
  variables:
    PLATFORM: 'darwin'
    ARCH: 'amd64'
  only:
    changes:
      - /*.go$/
  before_script:
    - apk add --no-cache git upx
  script:
    - go get -d -v ./...
    - GOOS=${PLATFORM} GOARCH=${ARCH} go build -ldflags="-s -w" -o ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH} *.go
    - upx ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}
    - gzip ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}
  artifacts:
    untracked: true

build-windows:
  stage: build
  image: golang:1.12.7-alpine
  variables:
    PLATFORM: 'windows'
    ARCH: 'amd64'
  only:
    changes:
      - /*.go$/
  before_script:
    - apk add --no-cache git upx
  script:
    - go get -d -v ./...
    - GOOS=${PLATFORM} GOARCH=${ARCH} go build -ldflags="-s -w" -o ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}.exe *.go
    - upx ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}.exe
    - gzip ${CI_PROJECT_NAME}-${PLATFORM}-${ARCH}.exe
  artifacts:
    untracked: true

release:
  stage: release
  image: python:alpine
  script:
    - pip3 install gitlab-release
    - gitlab-release *.gz
  only:
    - tags
